#functions to create dialogs in cli, dialog or xdialog
#include in top of script
#update 141110
#update 261110 return changed to be REPLY_NUM and REPLY_CHAR, added yes/no-fnct, changed file_fnct to use dialog and Xdialog...

TYPE="cli"		#dialog or cli
[ $(which dialog) ] && TYPE="dialog" && DIALOG=dialog
[ $(which Xdialog) ]  && TYPE="dialog" && [ "$DISPLAY" ] && DIALOG=Xdialog
[ "$DISPLAY" ] && [ "$(tty | grep not)" ] && [ ! "${DIALOG}" = "Xdialog" ] && exec rxvt -e sh -c $0

[ ! -f /tmp/PUPNGOERRORS.log ] && echo "" > /tmp/PUPNGOERRORS.log
#exec 2>/tmp/PUPNGOERRORS.log

fileselect_fc () {
clear
#file select input $1=STARTDIR
STARTDIR="$1"
[ "${STARTDIR}" = "" ] && STARTDIR=$HOME

if [ "${TYPE}" = "dialog" ]; then
  while :; do
    if [ "$DIALOG" = "dialog" ]; then
      FILE=`${DIALOG} --stdout --title "${TITLE}" --fselect $STARTDIR/ 14 48`
    else
      FILE=`${DIALOG} --stdout --title "${TITLE}" --no-buttons "Please choose a file" --fselect $STARTDIR/ 20 60`
    fi
    
    if [ ! $? -eq 0 ]; then
      REPLY_NUM="cancel"
      REPLY_CHAR="cancel"
      break	#cancel (or error)
    else
      REPLY_NUM=$FILE
      REPLY_CHAR=$FILE
      if [ -f "$REPLY_CHAR" ]; then
    	echo "$FILE" >/tmp/reply	#compatability with old scripts not using REPLY_NUM/REPLY_CHAR
        break
      else
        "${DIALOG}" --title "${TITLE}" --msgbox "File not found. Press OK to continue." 0 0
      fi
    fi
  done
fi

if [ "${TYPE}" = "cli" ]; then
echo "$TITLE"
echo "$TEXT - write 'cancel' to exit."		
while :; do
  read FILEPATH
  if [ "${FILEPATH}" = "cancel" ]; then
    REPLY_NUM="cancel"
    REPLY_CHAR="cancel"
    sync
    break
  else
    if [ -f "$FILEPATH" ]; then
      echo "$FILEPATH" >/tmp/reply
      REPLY_NUM="${FILEPATH}"
      REPLY_CHAR="${FILEPATH}"
      sync
      break
    else
      echo "File not found - try again or write cancel to exit/continue."
    fi
  fi
done
fi	
}

yesno_fc () {
if [ "${TYPE}" = "dialog" ]; then
  #ANSWER=`${DIALOG} --stdout --title "${TITLE}" --no-cancel --yesno "${TEXT}" 0 0` #>/tmp/reply
  ${DIALOG} --stdout  --title "${TITLE}" --no-cancel --yesno "${TEXT}" 0 0
  ANSWER=$?
  [ $ANSWER -eq 0 ] && REPLY_NUM="0" && REPLY_CHAR="Yes" #Yes chosen
  [ $ANSWER -eq 1 ] && REPLY_NUM="1" && REPLY_CHAR="No" #No chosen.
fi
if [ "${TYPE}" = "cli" ]; then	
  echo "Yes
No" > /tmp/choices
menu_fc
fi
}

message_fc () { #message function
#clear
if [ "${TYPE}" = "dialog" ]; then
  "${DIALOG}" --title "${TITLE}" --msgbox "${TEXT} Press OK to continue/quit." 0 0
fi
if [ "${TYPE}" = "cli" ]; then	
  echo "${TITLE}"
  echo "${TEXT}"
  echo "Press any key to continue/quit."
  read dummy
fi
}

input_fc () {	#to be changed after rewrite of all scripts...
clear
#used as normal input and file select: if $1=TEXT normal, if ="" file
MODE="$1"

if [ "${TYPE}" = "dialog" ]; then
  while :; do
    "${DIALOG}" --title "${TITLE}" --inputbox "${TEXT}" 0 0 2>/tmp/reply
    if [ $? -eq 1 ] && [ "$(cat /tmp/reply)" = "" ]; then
      REPLY_NUM="cancel"
      REPLY_CHAR="cancel"
      break	#cancel (or error)
    else
      REPLY_NUM=$(cat /tmp/reply)
      REPLY_CHAR=$(cat /tmp/reply)
    fi
    if [ ! "${REPLY_CHAR}" = "" ]; then
      break
    else
      "${DIALOG}" --title "${TITLE}" --msgbox "Please enter a value. Press OK to continue." 0 0
    fi
  done
fi

if [ "${TYPE}" = "cli" ]; then
echo "$TITLE"
echo "$TEXT - write 'cancel' to exit."		
while :; do
  read TEXTINPUT
  if [ "${TEXTINPUT}" = "cancel" ]; then
    REPLY_NUM=cancel
    REPLY_CHAR=cancel
    sync
    break
  fi
  if [ ! "${TEXTINPUT}" = "" ]; then
    REPLY_NUM=$TEXTINPUT
    REPLY_CHAR=$TEXTINPUT
    break
  else
    echo "Please enter a value - try again or write cancel to exit/continue."
  fi
done
fi
}

input_date () {
clear
if [ "${TYPE}" = "dialog" ]; then
  while :; do
  "${DIALOG}" --title "${TITLE}" --calendar "Please choose a date..." 0 0 2>/tmp/reply
    if [ ! $? -eq 0 ]; then
      echo "Canceled"
	  exit
    else
      #REPLY_NUM not used
      REPLY_CHAR=$(cat /tmp/reply)
      break
    fi
  done
fi

if [ "${TYPE}" = "cli" ]; then
  echo "$TITLE"
  echo "$TEXT"		
  while :; do
    echo -n "New Date: "
    read DATEINPUT
    D=$(echo $DATEINPUT |cut -d"/" -f1)
    M=$(echo $DATEINPUT |cut -d"/" -f2)
    Y=$(echo $DATEINPUT |cut -d"/" -f3)

    if [ ! $(echo $DATEINPUT | grep "[^0-9,\/]") ] && [ -n "$DATEINPUT" ] && [ "$D" -lt "32" ] && [ "$D" -gt "0" ] && [ "$M" -lt "13" ] && [ "$M" -gt "0" ] && [ "$Y" -lt "2050" ] && [ "$Y" -gt "1900" ]; then
      echo $D"/"$M"/"$Y > /tmp/reply
      DATEINPUT=
      return 0
    fi
    echo "Wrong date formate..."
    DATEINPUT=
  done
  REPLY_NUM=$(cat /tmp/reply)
  REPLY_CHAR=$(cat /tmp/reply)
fi
}

input_time () {
clear
if [ "${TYPE}" = "dialog" ]; then
  while :; do
    "${DIALOG}" --title "${TITLE}" --timebox "Please set the time..." 0 0 2>/tmp/reply
    if [ ! $? -eq 0 ]; then
      echo "Canceled"
	  exit
    else
      REPLY_NUM=$(cat /tmp/reply)
      REPLY_CHAR=$(cat /tmp/reply)
      break
    fi
  done
fi

if [ "${TYPE}" = "cli" ]; then
  echo "$TITLE"
  echo "$TEXT"		
  while :; do
    echo -n "New Time: " 
    read TIMEINPUT
    H=$(echo $TIMEINPUT |cut -d":" -f1)
    M=$(echo $TIMEINPUT |cut -d":" -f2)
    if [ ! `echo $TIMEINPUT | grep "[^0-9,:]"` ] && [ -n "$TIMEINPUT" ] && [ $H -lt 24 ] && [ $H -gt 0 ] && [ $M -lt 60 ] && [ $M -gt 0 ]; then
      echo $H":"$M":00" > /tmp/reply
      TIMEINPUT=
      return 0
    fi
    echo "Wrong time formate..."
    TIMEINPUT=
  done
  #REPLY_NUM not used
  REPLY_CHAR=$(cat /tmp/reply)
fi
}

menu_fc() {	#function (prototype only!) to respond with dialog or to shell
echo -n > /tmp/selectlist
clear
if [ "${TYPE}" = "dialog" ]; then
  WIDTH=0
  ROWS=0
  HEIGHT=0
  ALIGN=""
  if [ "${DIALOG}" = "Xdialog" ]; then
  #<height> <width> <menu height> ...xdialog sizes really confusing...
  ALIGN="--left"
    WIDTH=$(wc -L /tmp/choices | cut -d "/" -f 1)
    echo "${TEXT}" > /tmp/tmp_text
    WIDTH2=$(wc -L /tmp/tmp_text | cut -d "/" -f 1)
     
    if [ $WIDTH -le $WIDTH2 ]; then
    WIDTH=${WIDTH2}
      if [ $WIDTH -ge 60 ]; then
        WIDTH=60
      fi
    fi
    let WIDTH=WIDTH+10
    
    ROWS=$(wc -l /tmp/choices | cut -d "/" -f 1)
    let ROWS=ROWS+1
    
    HEIGHT=$(wc -l /tmp/tmp_text | cut -d "/" -f 1)
    let HEIGHT=HEIGHT+12
    
    rm -f /tmp/tmp_text
    if [ $HEIGHT -gt 40 ]; then
      HEIGHT=40
    fi 
  fi
  echo "#!/bin/ash" > /tmp/dlg
  echo "$DIALOG --title \"${TITLE}\" $ALIGN --no-cancel --menu \"${TEXT}\" $HEIGHT $WIDTH $ROWS\\" >> /tmp/dlg
  COUNTER=0
  while read CHOICE; do
    echo "    $COUNTER \"$CHOICE\"\\" >> /tmp/dlg
    #create /tmp/selectlist
    echo "$COUNTER) $CHOICE" >> /tmp/selectlist
    let COUNTER=COUNTER+1
  done </tmp/choices
  echo -n "    2> /tmp/reply" >> /tmp/dlg
  
fi
if [ "${TYPE}" = "cli" ]; then
  COUNTER=0
  
  echo "#!/bin/ash
  echo \"\"
  echo \"\"
  echo \"\"
  echo \"${TITLE}\"
  echo \"${TEXT}\"
  echo \"\""> /tmp/dlg
  while read CHOICE; do
    echo "echo \"$COUNTER. $CHOICE\"" >> /tmp/dlg
    #create /tmp/selectlist
    echo "$COUNTER) $CHOICE" >> /tmp/selectlist
    let COUNTER=COUNTER+1
  done </tmp/choices
  let COUNTER=COUNTER-1
  echo "while :; do
  echo
  read REPLY
  if [ \$REPLY -ge 0 ]; then
  if [ \$REPLY -le $COUNTER ]; then
  echo \$REPLY >/tmp/reply; break;
  else
  echo \"??\"
  fi
  fi
  done" >> /tmp/dlg
fi
#run /tmp/dlg
chmod 777 /tmp/dlg
/tmp/dlg
#check response
[ "$(cat /tmp/reply)" = "" ] && echo "Cancel pressed or an error has occured - program will exit" && exit
REPLY_NUM=$(cat /tmp/reply)
while read line; do
if [ ! "${line}" = "" ]; then
  TEMP1=$(echo "$line" | wc -w)
  if [ $TEMP1 -eq 1 ]; then
    REPLY_NUM=$(echo "$line")
  fi
fi
done < /tmp/reply
REPLY_CHAR=$(cat /tmp/selectlist | grep ^$REPLY_NUM\) | cut -d " " -f2-100)
}



